=== modified file '.bzrignore'
--- .bzrignore	2011-05-27 08:25:15 +0000
+++ .bzrignore	2012-01-18 13:07:18 +0000
@@ -1,19 +1,7 @@
-data/xapian/flintlock
-data/xapian/iamflint
-data/xapian/postlist.baseA
-data/xapian/postlist.baseB
-data/xapian/postlist.DB
-data/xapian/record.baseA
-data/xapian/record.baseB
-data/xapian/record.DB
-data/xapian/termlist.baseA
-data/xapian/termlist.baseB
-data/xapian/termlist.DB
-data/xapian/value.baseA
-data/xapian/value.baseB
-data/xapian/value.DB
-data/xapian/iamchert
-data/xapian/spelling.DB
-data/xapian/spelling.baseA
-data/xapian/spelling.baseB
 build/
+test/.coverage
+test/coverage_html
+test/coverage_summary
+test/output
+help/*
+data/xapian/*
\ No newline at end of file

=== modified file 'README'
--- README	2011-07-27 16:43:26 +0000
+++ README	2012-01-18 21:27:30 +0000
@@ -7,6 +7,25 @@
 
 All non UI code must come with tests in the test/ subdirectoy.
 
+To setup your development environment, you'll need to ensure the following
+extra packages are installed:
+
+sudo apt-get install xvfb python-coverage python-mock python-aptdaemon.test \
+     python-qt4 python-unittest2 python-lxml
+sudo apt-get build-dep software-center
+
+You can then run tests with:
+
+cd test;make
+
+You can run a developer instance with:
+
+python setup.py build
+./software-center
+
+The initial launch of this will take a bit as it will build a private
+search database but this is only needed once.
+
 == query parser ==
 
 The query parser understands :
@@ -15,7 +34,7 @@
 
 == aptdaemon ==
  * the dbus limits for the system bus are rather low, this means that
-   adding  <limit name="max_match_rules_per_connection">512</limit> 
+   adding  <limit name="max_match_rules_per_connection">512</limit>
    and using something bigger than 512 is a good idea
 
 == environment ==
@@ -26,7 +45,7 @@
 SOFTWARE_CENTER_USE_BUILTIN_LOGIN - use built-in login instead of ubuntu-sso-client
 SOFTWARE_CENTER_APPDETAILS_WEBKIT - use the webkit appdetails instead of gtk
 APPVIEW_DEBUG_TERMS - show debug output for the terms in a search
-SOFTWARE_CENTER_BUY_HOST - use a alternative hosts to query for pay software
+SOFTWARE_CENTER_AGENT_HOST - use a alternative hosts to query for pay software
 SOFTWARE_CENTER_REVIEWS_HOST - a alternative host for the ratings&reviews
 SOFTWARE_CENTER_DEBUG_HTTP - enable httplib2 debuging
 
@@ -54,7 +73,7 @@
 SCPkgname - e.g. "gimp"
 
 Additional .menu files can be added in:
-/usr/share/app-install/menu.d 
+/usr/share/app-install/menu.d
 that software-center will read and parse.
 
 == XAPIAN ==
@@ -66,9 +85,9 @@
 AS - archive pocket (main)
 AE - archive section (mail, base, ...)
 AC - category (AudioVideo)
-AM - MimeType (application/x-ogg) 
+AM - MimeType (application/x-ogg)
 AT - type (Application)
-AH - channel 
+AH - channel
 
 
 The following values are used:
@@ -89,5 +108,5 @@
 XAPIAN_VALUE_PURCHASED_DATE - the data a for-pay app was purchased (only available after the software-center-agent server was queried)
 XAPIAN_VALUE_SCREENSHOT_URL - a (optional) screenshot url that overrides the default
 XAPIAN_VALUE_ICON_NEEDS_DOWNLOAD - icon needs to be fetched
-XAPIAN_VALUE_THUMBNAIL_URL - thumbnail url 
+XAPIAN_VALUE_THUMBNAIL_URL - thumbnail url
 

=== modified file 'debian/changelog'
--- debian/changelog	2012-01-17 20:38:09 +0000
+++ debian/changelog	2012-01-19 15:52:33 +0000
@@ -7,13 +7,39 @@
     - Small bugfix to ensure that switching language or 
       reviews sort method resets the reviews page, and 
       added tests.
+  * lp:~elachuni/software-center/relax-origin-distroseries:
+    - provide "relaxed" mode for fetching reviews if the exact
+      review matcher does not find anything (LP: #766951)
 
   [ Michael Vogt ]
   * lp:~mvo/software-center/improve-debug-in-piston-generic-helper:
     - improve debug output of piston-generic-helper and a README 
       with examples how it can be used to debug server side issues
-
- -- Gary Lasker <gary.lasker@canonical.com>  Tue, 17 Jan 2012 15:36:33 -0500
+  * lp:~mvo/software-center/review-language-i18n:
+    - make the language selection combo in the reviews widget
+      nicer by adding a proper i18n name to it
+  * lp:~mvo/software-center/trivial-move-gui-helpers:
+    - move rnr_helpers.py to softwarecenter/ui/gtk3/review_gui_helper.py
+      as it belongs there and add to POTFILE.in
+  
+  [ Michael Nelson ]
+  * lp:~michael.nelson/software-center/833982-purchased-app-not-available,
+    lp:~michael.nelson/software-center/917137-previous-purchases-empty-precise-2:
+    - refactor/cleanup parser code and update for API 2.0 (LP: #917137)
+
+  [ Danny Tamez ]
+  * lp:~zematynnad/software-center/rename_host_var_918270:
+    - rename the env variable SOFTWARE_CENTER_BUY_HOST  to the more
+      correct SOFTWARE_CENTER_AGENT_HOST, but support the former as a
+      fallback, update corresponding unit test (LP: #918270)
+  
+  [ Gary Lasker ]
+  * lp:~gary-lasker/software-center/staging-certs-2:
+    - add new SOFTWARE_CENTER_FORCE_DISABLE_CERTS_CHECK environment that
+      can be used to disable cert checking to run e.g. against a local dev
+      instance (LP: #918746)
+
+ -- Gary Lasker <gary.lasker@canonical.com>  Thu, 19 Jan 2012 10:52:04 -0500
 
 software-center (5.1.6) precise; urgency=low
 

=== modified file 'debian/control'
--- debian/control	2012-01-05 11:10:58 +0000
+++ debian/control	2012-01-18 18:04:04 +0000
@@ -21,6 +21,7 @@
 Architecture: all
 Depends: ${python:Depends},
          ${misc:Depends},
+         iso-codes,
          app-install-data (>= 0.4.0),
          aptdaemon (>= 0.40),
          software-center-aptdaemon-plugins,

=== modified file 'po/POTFILES.in'
--- po/POTFILES.in	2011-11-15 10:54:54 +0000
+++ po/POTFILES.in	2012-01-19 12:48:54 +0000
@@ -33,6 +33,7 @@
 softwarecenter/db/debfile.py
 softwarecenter/distro/SUSELINUX.py
 softwarecenter/ui/gtk3/app.py
+softwarecenter/ui/gtk3/review_gui_helper.py
 softwarecenter/ui/gtk3/dialogs/__init__.py
 softwarecenter/ui/gtk3/dialogs/deauthorize_dialog.py
 softwarecenter/ui/gtk3/dialogs/dependency_dialogs.py

=== removed file 'run_fake_gtk3.sh'
--- run_fake_gtk3.sh	2011-08-15 11:55:13 +0000
+++ run_fake_gtk3.sh	1970-01-01 00:00:00 +0000
@@ -1,7 +0,0 @@
-#!/bin/sh
-
-export SOFTWARE_CENTER_FAKE_REVIEW_API="1"
-
-# s-c
-export PYTHONPATH=$(pwd)
-./software-center-gtk3 $@

=== modified file 'run_local.sh'
--- run_local.sh	2011-08-19 11:54:50 +0000
+++ run_local.sh	2012-01-18 23:10:42 +0000
@@ -2,6 +2,7 @@
 
 export SOFTWARE_CENTER_REVIEWS_HOST="http://127.0.0.1:8000/reviews/api/1.0"
 export SOFTWARE_CENTER_FORCE_NON_SSL=1
+export SOFTWARE_CENTER_FORCE_DISABLE_CERTS_CHECK=1
 
 # sso
 export USSOC_SERVICE_URL="https://login.staging.ubuntu.com/api/1.0"

=== removed file 'run_local_gtk3.sh'
--- run_local_gtk3.sh	2011-08-15 11:55:13 +0000
+++ run_local_gtk3.sh	1970-01-01 00:00:00 +0000
@@ -1,18 +0,0 @@
-#!/bin/sh
-
-export SOFTWARE_CENTER_REVIEWS_HOST="http://127.0.0.1:8000/reviews/api/1.0"
-export SOFTWARE_CENTER_FORCE_NON_SSL=1
-
-# sso
-export USSOC_SERVICE_URL="https://login.staging.ubuntu.com/api/1.0"
-pkill -f ubuntu-sso-login
-python /usr/lib/ubuntu-sso-client/ubuntu-sso-login &
-
-# s-c
-export PYTHONPATH=$(pwd)
-
-if [ ! -d "./build" ]; then
-    echo "Please run: 'python setup.py build' before $0"
-fi
-
-./software-center-gtk3 $@

=== modified file 'software-center'
--- software-center	2012-01-06 16:59:29 +0000
+++ software-center	2012-01-19 00:43:31 +0000
@@ -45,6 +45,8 @@
 # Enable Xapian's CJK tokenizer (see LP: #745243)
 os.environ['XAPIAN_CJK_NGRAM'] = '1'
 
+LOG = logging.getLogger("softwarecenter")
+
 if __name__ == "__main__":
 
     parser = OptionParser("usage: %prog [options] [package-name | apturl | deb-file]", 
@@ -124,8 +126,15 @@
     # on exit. However its IMPORTANT to set it as libsoup is *not* secure
     # by default (see bugzilla #666280 and #666276)
     from gi.repository import WebKit as webkit
-    session = webkit.get_default_session()
-    session.set_property("ssl-ca-file", "/etc/ssl/certs/ca-certificates.crt")
+    # enable certificates validation in webkit views unless specified otherwise
+    if not "SOFTWARE_CENTER_FORCE_DISABLE_CERTS_CHECK" in os.environ:
+        session = webkit.get_default_session()
+        session.set_property("ssl-ca-file", "/etc/ssl/certs/ca-certificates.crt")
+    else:
+        # WARN the user!! Do not remove this
+        LOG.warning("SOFTWARE_CENTER_FORCE_DISABLE_CERTS_CHECK " +
+                    "has been specified, all purchase transactions " + 
+                    "are now INSECURE and UNENCRYPTED!!")
 
     # create the app
     from softwarecenter.ui.gtk3.app import SoftwareCenterAppGtk3

=== modified file 'softwarecenter/backend/reviews/__init__.py'
--- softwarecenter/backend/reviews/__init__.py	2012-01-06 05:43:34 +0000
+++ softwarecenter/backend/reviews/__init__.py	2012-01-17 21:25:58 +0000
@@ -253,7 +253,7 @@
         return False
 
     def get_reviews(self, application, callback, page=1, language=None,
-                    sort=0):
+                    sort=0, relaxed=False):
         """run callback f(app, review_list) 
            with list of review objects for the given
            db.database.Application object
@@ -456,7 +456,8 @@
         return random.choice(self.LOREM.split("\n\n"))
     def _random_summary(self):
         return random.choice(self.SUMMARIES)
-    def get_reviews(self, application, callback, page=1, language=None, sort=0):
+    def get_reviews(self, application, callback, page=1, language=None,
+        sort=0, relaxed=False):
         if not application in self._review_stats_cache:
             self.get_review_stats(application)
         stats = self._review_stats_cache[application]
@@ -628,7 +629,8 @@
         self._review_stats_cache = {}
         self._reviews_cache = {}
 
-    def get_reviews(self, application, callback, page=1, language=None, sort=0):
+    def get_reviews(self, application, callback, page=1, language=None,
+        sort=0, relaxed=False):
         callback(application, [])
 
     def get_review_stats(self, application):

=== modified file 'softwarecenter/backend/reviews/rnr.py'
--- softwarecenter/backend/reviews/rnr.py	2012-01-05 14:13:59 +0000
+++ softwarecenter/backend/reviews/rnr.py	2012-01-17 21:25:58 +0000
@@ -65,7 +65,7 @@
 
     # reviews
     def get_reviews(self, translated_app, callback, page=1, 
-                    language=None, sort=0):
+                    language=None, sort=0, relaxed=False):
         """ public api, triggers fetching a review and calls callback
             when its ready
         """
@@ -77,23 +77,27 @@
         if language is None:
             language = self.language
         # gather args for the helper
-        try:
-            origin = self.cache.get_origin(app.pkgname)
-        except:
-            # this can happen if e.g. the app has multiple origins, this
-            # will be handled later
-            origin = None
-        # special case for not-enabled PPAs
-        if not origin and self.db:
-            details = app.get_details(self.db)
-            ppa = details.ppaname
-            if ppa:
-                origin = "lp-ppa-%s" % ppa.replace("/", "-")
-        # if there is no origin, there is nothing to do
-        if not origin:
-            callback(app, [])
-            return
-        distroseries = self.distro.get_codename()
+        if relaxed:
+            origin = 'any'
+            distroseries = 'any'
+        else:
+            try:
+                origin = self.cache.get_origin(app.pkgname)
+            except:
+                # this can happen if e.g. the app has multiple origins, this
+                # will be handled later
+                origin = None
+            # special case for not-enabled PPAs
+            if not origin and self.db:
+                details = app.get_details(self.db)
+                ppa = details.ppaname
+                if ppa:
+                    origin = "lp-ppa-%s" % ppa.replace("/", "-")
+            # if there is no origin, there is nothing to do
+            if not origin:
+                callback(app, [])
+                return
+            distroseries = self.distro.get_codename()
         # run the command and add watcher
         cmd = [os.path.join(softwarecenter.paths.datadir, PistonHelpers.GET_REVIEWS),
                "--language", language, 

=== modified file 'softwarecenter/backend/scagent.py'
--- softwarecenter/backend/scagent.py	2012-01-06 05:43:34 +0000
+++ softwarecenter/backend/scagent.py	2012-01-17 15:56:14 +0000
@@ -92,7 +92,7 @@
     def _on_query_available_data(self, spawner, piston_available):
         self.emit("available", piston_available)
 
-    def query_available_for_me(self, oauth_token, openid_identifier):
+    def query_available_for_me(self):
         spawner = SpawnHelper()
         spawner.parent_xid = self.xid
         spawner.ignore_cache = self.ignore_cache
@@ -100,7 +100,9 @@
         spawner.connect("error", lambda spawner, err: self.emit("error", err))
         spawner.needs_auth = True
         spawner.run_generic_piston_helper(
-            "SoftwareCenterAgentAPI", "subscriptions_for_me")
+            "SoftwareCenterAgentAPI", "subscriptions_for_me",
+            complete_only=True)
+
     def _on_query_available_for_me_data(self, spawner, piston_available_for_me):
         self.emit("available-for-me", piston_available_for_me)
 
@@ -147,7 +149,7 @@
     scagent.connect("exhibits", _exhibits)
     scagent.connect("error", _error)
     #scagent.query_available("natty", "i386")
-    #scagent.query_available_for_me("dummy_oauth", "dummy openid")
+    #scagent.query_available_for_me()
     scagent.query_exhibits()
 
     from gi.repository import Gtk

=== modified file 'softwarecenter/db/update.py'
--- softwarecenter/db/update.py	2012-01-05 08:52:42 +0000
+++ softwarecenter/db/update.py	2012-01-18 09:38:45 +0000
@@ -26,6 +26,7 @@
 import time
 
 from gi.repository import GObject
+from piston_mini_client import PistonResponseObject
 
 from softwarecenter.utils import utf8
 
@@ -131,66 +132,122 @@
     def desktopf(self):
         """ return the file that the AppInfo comes from """
 
-class SoftwareCenterAgentParser(AppInfoParserBase):
+class SCAApplicationParser(AppInfoParserBase):
     """ map the data we get from the software-center-agent """
 
-    # map from requested key to sca_entry attribute
+    # map from requested key to sca_application attribute
     MAPPING = { 'Name'       : 'name',
                 'Price'      : 'price',
                 'Package'    : 'package_name',
                 'Categories' : 'categories',
                 'Channel'    : 'channel',
-                'Deb-Line'   : 'deb_line',
                 'Signing-Key-Id' : 'signing_key_id',
                 'License'    : 'license',
                 'Date-Published' : 'date_published',
-                'Purchased-Date' : 'purchase_date',
-                'License-Key' : 'license_key',
-                'License-Key-Path' : 'license_key_path',
                 'PPA'        : 'archive_id',
-                'Icon'       : 'icon',
                 'Screenshot-Url' : 'screenshot_url',
                 'Thumbnail-Url' : 'thumbnail_url',
                 'Video-Url' :  'video_url',
                 'Icon-Url'   : 'icon_url',
                 'Support-Url'   : 'support_url',
+                'Description' : 'Description',
+                'Comment' : 'Comment',
               }
 
     # map from requested key to a static data element
     STATIC_DATA = { 'Type' : 'Application',
                   }
 
-    def __init__(self, sca_entry):
-        self.sca_entry = sca_entry
+    def __init__(self, sca_application):
+        self.sca_application = sca_application
         self.origin = "software-center-agent"
         self._apply_exceptions()
+
     def _apply_exceptions(self):
         # for items from the agent, we use the full-size screenshot for
         # the thumbnail and scale it for display, this is done because
         # we no longer keep thumbnail versions of screenshots on the server
-        if (hasattr(self.sca_entry, "screenshot_url") and 
-            not hasattr(self.sca_entry, "thumbnail_url")):
-            self.sca_entry.thumbnail_url = self.sca_entry.screenshot_url
-        if hasattr(self.sca_entry, "description"):
-            self.sca_entry.Comment = self.sca_entry.description.split("\n")[0]
-            self.sca_entry.Description = "\n".join(self.sca_entry.description.split("\n")[1:])
+        if (hasattr(self.sca_application, "screenshot_url") and 
+            not hasattr(self.sca_application, "thumbnail_url")):
+            self.sca_application.thumbnail_url = self.sca_application.screenshot_url
+        if hasattr(self.sca_application, "description"):
+            self.sca_application.Comment = self.sca_application.description.split("\n")[0].strip()
+            self.sca_application.Description = "\n".join(
+                self.sca_application.description.split("\n")[1:]).strip()
+        # WARNING: item.name needs to be different than
+        #          the item.name in the DB otherwise the DB
+        #          gets confused about (appname, pkgname) duplication
+        self.sca_application.name = utf8(_("%s (already purchased)")) % utf8(
+            self.sca_application.name)
+
+        # XXX 2012-01-16 bug=917109
+        # We can remove these work-arounds once the above bug is fixed on
+        # the server. Until then, we fake a channel here and empty category
+        # to make the parser happy. Note: available_apps api call includes
+        # these already, it's just the apps with subscriptions_for_me which
+        # don't currently.
+        self.sca_application.channel = AVAILABLE_FOR_PURCHASE_MAGIC_CHANNEL_NAME
+        if not hasattr(self.sca_application, 'categories'):
+            self.sca_application.categories = ""
+
     def get_desktop(self, key, translated=True):
         if key in self.STATIC_DATA:
             return self.STATIC_DATA[key]
-        return getattr(self.sca_entry, self._apply_mapping(key))
+        return getattr(self.sca_application, self._apply_mapping(key))
+
     def get_desktop_categories(self):
         try:
-            return ['DEPARTMENT:' + self.sca_entry.department[-1]] + self._get_desktop_list("Categories")
+            return ['DEPARTMENT:' + self.sca_application.department[-1]] + self._get_desktop_list("Categories")
         except:
             return self._get_desktop_list("Categories")
+
     def has_option_desktop(self, key):
         return (key in self.STATIC_DATA or
-                hasattr(self.sca_entry, self._apply_mapping(key)))
+                hasattr(self.sca_application, self._apply_mapping(key)))
+
     @property
     def desktopf(self):
         return self.origin
 
 
+class SCAPurchasedApplicationParser(SCAApplicationParser):
+    """A purchased application hase some additional subscription attributes."""
+
+    def __init__(self, sca_subscription):
+        # The sca_subscription is a PistonResponseObject, whereas any child
+        # objects are normal Python dicts.
+        self.sca_subscription = sca_subscription
+        super(SCAPurchasedApplicationParser, self).__init__(
+            PistonResponseObject.from_dict(sca_subscription.application))
+        self.sca_application.channel = (
+            PURCHASED_NEEDS_REINSTALL_MAGIC_CHANNEL_NAME)
+
+    SUBSCRIPTION_MAPPING = { 
+        'Deb-Line'   : 'deb_line',
+        'Purchased-Date' : 'purchase_date',
+        'License-Key' : 'license_key',
+        'License-Key-Path' : 'license_key_path',
+        }
+
+    MAPPING = dict(
+        SCAApplicationParser.MAPPING.items() + SUBSCRIPTION_MAPPING.items())
+
+    def get_desktop(self, key, translated=True):
+        if self._subscription_has_option_desktop(key):
+            return getattr(self.sca_subscription, self._apply_mapping(key))
+        return super(SCAPurchasedApplicationParser, self).get_desktop(key)
+
+    def _subscription_has_option_desktop(self, key):
+        return hasattr(
+            self.sca_subscription, self._apply_mapping(key))
+
+    def has_option_desktop(self, key):
+        subscription_has_option = self._subscription_has_option_desktop(key)
+        application_has_option = super(
+            SCAPurchasedApplicationParser, self).has_option_desktop(key)
+        return subscription_has_option or application_has_option
+
+
 class JsonTagSectionParser(AppInfoParserBase):
 
     MAPPING = { 'Name'       : 'application_name',
@@ -505,15 +562,7 @@
         #    continue
         # index the item
         try:
-            # we fake a channel here
-            item.channel = PURCHASED_NEEDS_REINSTALL_MAGIC_CHANNEL_NAME
-            # and empty category to make the parser happy
-            item.categories = ""
-            # WARNING: item.name needs to be different than
-            #          the item.name in the DB otherwise the DB
-            #          gets confused about (appname, pkgname) duplication
-            item.name = utf8(_("%s (already purchased)")) % utf8(item.name)
-            parser = SoftwareCenterAgentParser(item)
+            parser = SCAPurchasedApplicationParser(item)
             index_app_info_from_parser(parser, db_purchased, cache)
         except Exception as e:
             LOG.exception("error processing: %s " % e)
@@ -560,10 +609,8 @@
         while context.pending():
             context.iteration()
         try:
-            # magic channel
-            entry.channel = AVAILABLE_FOR_PURCHASE_MAGIC_CHANNEL_NAME
             # now the normal parser
-            parser = SoftwareCenterAgentParser(entry)
+            parser = SCAApplicationParser(entry)
             index_app_info_from_parser(parser, db, cache)
         except Exception as e:
             LOG.warning("error processing: %s " % e)
@@ -663,20 +710,21 @@
         # date published
         if parser.has_option_desktop("X-AppInstall-Date-Published"):
             date_published = parser.get_desktop("X-AppInstall-Date-Published")
-            # strip the subseconds from the end of the published date string
-            date_published = str(date_published).split(".")[0]
-            doc.add_value(XapianValues.DATE_PUBLISHED,
-                          date_published)
-            # we use the date published value for the cataloged time as well
-            if "catalogedtime" in axi_values:
-                LOG.debug(
-                        ("pkgname: %s, date_published cataloged time is: %s" %
-                             (pkgname, parser.get_desktop("date_published"))))
-                date_published_sec = time.mktime(
-                                        time.strptime(date_published,
-                                                      "%Y-%m-%d  %H:%M:%S"))
-                doc.add_value(axi_values["catalogedtime"], 
-                              xapian.sortable_serialise(date_published_sec))
+            if date_published:
+                # strip the subseconds from the end of the published date string
+                date_published = str(date_published).split(".")[0]
+                doc.add_value(XapianValues.DATE_PUBLISHED,
+                              date_published)
+                # we use the date published value for the cataloged time as well
+                if "catalogedtime" in axi_values:
+                    LOG.debug(
+                            ("pkgname: %s, date_published cataloged time is: %s" %
+                                 (pkgname, parser.get_desktop("date_published"))))
+                    date_published_sec = time.mktime(
+                                            time.strptime(date_published,
+                                                          "%Y-%m-%d  %H:%M:%S"))
+                    doc.add_value(axi_values["catalogedtime"], 
+                                  xapian.sortable_serialise(date_published_sec))
         # purchased date
         if parser.has_option_desktop("X-AppInstall-Purchased-Date"):
             date = parser.get_desktop("X-AppInstall-Purchased-Date")

=== modified file 'softwarecenter/enums.py'
--- softwarecenter/enums.py	2012-01-05 15:20:45 +0000
+++ softwarecenter/enums.py	2012-01-18 21:27:30 +0000
@@ -27,12 +27,12 @@
 SOFTWARE_CENTER_SSO_DESCRIPTION = _(
     "To reinstall previous purchases, sign in to the "
     "Ubuntu Single Sign-On account you used to pay for them.")
-        
+
 
 # buy-something base url
 #BUY_SOMETHING_HOST = "http://localhost:8000/"
-BUY_SOMETHING_HOST = os.environ.get("SOFTWARE_CENTER_BUY_HOST") or "https://software-center.ubuntu.com"
-BUY_SOMETHING_HOST_ANONYMOUS = os.environ.get("SOFTWARE_CENTER_BUY_HOST") or "http://software-center.ubuntu.com"
+BUY_SOMETHING_HOST = os.environ.get("SOFTWARE_CENTER_AGENT_HOST") or os.environ.get("SOFTWARE_CENTER_BUY_HOST") or "https://software-center.ubuntu.com"
+BUY_SOMETHING_HOST_ANONYMOUS = os.environ.get("SOFTWARE_CENTER_AGENT_HOST") or os.environ.get("SOFTWARE_CENTER_BUY_HOST") or "http://software-center.ubuntu.com"
 
 # recommender
 RECOMMENDER_HOST = os.environ.get("SOFTWARE_CENTER_RECOMMENDER_HOST") or "https://recommender.software-center.ubuntu.com"
@@ -43,7 +43,7 @@
 SSO_LOGIN_HOST = UBUNTU_SSO_SERVICE
 
 
-# version of the database, every time something gets added (like 
+# version of the database, every time something gets added (like
 # terms for mime-type) increase this (but keep as a string!)
 DB_SCHEMA_VERSION = "6"
 
@@ -175,7 +175,7 @@
     PURCHASED_BUT_REPO_MUST_BE_ENABLED,
     ERROR,
     # the package is not found in the DB or cache
-    NOT_FOUND, 
+    NOT_FOUND,
     # this *needs* to be last (for test_appdetails.py) and means
     # something went wrong and we don't have a state for this PKG
     UNKNOWN,
@@ -218,8 +218,8 @@
 TOP_RATED_CAROUSEL_LIMIT = 12
 
 from .version import VERSION, DISTRO, RELEASE, CODENAME
-USER_AGENT="Software Center/%s (N;) %s/%s (%s)" % (VERSION, 
-                                                   DISTRO, 
+USER_AGENT="Software Center/%s (N;) %s/%s (%s)" % (VERSION,
+                                                   DISTRO,
                                                    RELEASE,
                                                    CODENAME)
 

=== modified file 'softwarecenter/i18n.py'
--- softwarecenter/i18n.py	2011-10-13 13:48:13 +0000
+++ softwarecenter/i18n.py	2012-01-18 19:48:08 +0000
@@ -16,6 +16,7 @@
 # this program; if not, write to the Free Software Foundation, Inc.,
 # 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+import locale
 import logging
 import os
 LOG = logging.getLogger(__name__)
@@ -26,14 +27,29 @@
 # can be abbreved
 FULL = ["pt_BR", 
         "zh_CN", "zh_TW"]
+
+def init_locale():
+    try:
+        locale.setlocale(locale.LC_ALL, "")
+        # we need this for bug #846038, with en_NG setlocale() is fine
+        # but the next getlocale() will crash (fun!)
+        locale.getlocale()
+    except:
+        LOG.exception("setlocale failed, resetting to C")
+        locale.setlocale(locale.LC_ALL, "C")
+
+
 def get_languages():
     """Helper that returns the split up languages"""
-    if not "LANGUAGE" in os.environ:
+    langs = []
+    if "LANGUAGE" in os.environ:
+        langs = os.environ["LANGUAGE"].split(":")
+        for lang in langs[:]:
+            if "_" in lang and not lang in FULL:
+                langs.remove(lang)
+    # fallback
+    if not langs:
         return [get_language()]
-    langs = os.environ["LANGUAGE"].split(":")
-    for lang in langs[:]:
-        if "_" in lang and not lang in FULL:
-            langs.remove(lang)
     return langs
 
 def get_language():
@@ -51,3 +67,16 @@
     if language in FULL:
         return language
     return language.split("_")[0]
+
+def langcode_to_name(langcode):
+    import xml.etree.ElementTree
+    from gettext import dgettext
+    for iso in ["iso_639_3", "iso_639"]:
+        path = os.path.join("/usr/share/xml/iso-codes/", iso+".xml")
+        if os.path.exists(path):
+            root = xml.etree.ElementTree.parse(path)
+            xpath = ".//iso_639_3_entry[@part1_code='%s']" % langcode
+            match = root.find(xpath)
+            if match is not None:
+                return dgettext(iso, match.attrib["name"])
+    return langcode

=== modified file 'softwarecenter/ui/gtk3/app.py'
--- softwarecenter/ui/gtk3/app.py	2012-01-12 21:09:38 +0000
+++ softwarecenter/ui/gtk3/app.py	2012-01-18 19:48:08 +0000
@@ -22,7 +22,6 @@
 
 import atexit
 import collections
-import locale
 import dbus
 import dbus.service
 from dbus.mainloop.glib import DBusGMainLoop
@@ -48,6 +47,7 @@
 # db imports
 from softwarecenter.db.application import Application
 from softwarecenter.db import DebFileApplication
+from softwarecenter.i18n import init_locale
 
 # misc imports
 from softwarecenter.plugin import PluginManager
@@ -187,15 +187,7 @@
         gettext.bindtextdomain("software-center", "/usr/share/locale")
         gettext.textdomain("software-center")
 
-        try:
-            locale.setlocale(locale.LC_ALL, "")
-            # we need this for bug #846038, with en_NG setlocale() is fine
-            # but the next getlocale() will crash (fun!)
-            locale.getlocale()
-        except:
-            LOG.exception("setlocale failed, resetting to C")
-            locale.setlocale(locale.LC_ALL, "C")
-
+        init_locale()
 
         if "SOFTWARE_CENTER_DEBUG_TABS" in os.environ:
             self.notebook_view.set_show_tabs(True)
@@ -591,9 +583,7 @@
         # appmanager needs to know about the oauth token for the reinstall
         # previous purchases add_license_key call
         self.app_manager.oauth_token = oauth_result
-        # consumer key is the openid identifier
-        self.scagent.query_available_for_me(oauth_result["token"],
-                                            oauth_result["consumer_key"])
+        self.scagent.query_available_for_me()
 
     def _on_style_updated(self, widget, init_css_callback, *args):
         init_css_callback(widget, *args)

=== renamed file 'softwarecenter/backend/reviews/rnr_helpers.py' => 'softwarecenter/ui/gtk3/review_gui_helper.py'
=== modified file 'softwarecenter/ui/gtk3/views/appdetailsview.py'
--- softwarecenter/ui/gtk3/views/appdetailsview.py	2012-01-17 17:22:11 +0000
+++ softwarecenter/ui/gtk3/views/appdetailsview.py	2012-01-18 16:32:18 +0000
@@ -751,6 +751,7 @@
         # reviews
         self._reviews_server_page = 1
         self._reviews_server_language = None
+        self._reviews_relaxed = False
         self._review_sort_method = 0
         
         # switches
@@ -814,12 +815,14 @@
     
     def _on_review_sort_method_changed(self, uilist, sort_method):
         self._reviews_server_page = 1
+        self._reviews_relaxed = False
         self._review_sort_method = sort_method
         self.reviews.clear()
         self._do_load_reviews()
 
     def _on_reviews_in_different_language_clicked(self, uilist, language):
         self._reviews_server_page = 1
+        self._reviews_relaxed = False
         self._reviews_server_language = language
         self.reviews.clear()
         self._do_load_reviews()
@@ -830,7 +833,8 @@
             self.app, self._reviews_ready_callback, 
             page=self._reviews_server_page,
             language=self._reviews_server_language,
-            sort=self._review_sort_method)
+            sort=self._review_sort_method,
+            relaxed=self._reviews_relaxed)
 
     def _review_update_single(self, action, review):
         if action == 'replace':
@@ -863,6 +867,19 @@
         if self.app.pkgname != app.pkgname:
             return
 
+        # Start fetching relaxed reviews if we retrieved no data
+        # (and if we weren't already relaxed)
+        if not reviews_data and not self._reviews_relaxed:
+            self._reviews_relaxed = True
+            self._reviews_server_page = 1
+            self.review_loader.get_reviews(
+                self.app, self._reviews_ready_callback, 
+                page=self._reviews_server_page,
+                language=self._reviews_server_language,
+                sort=self._review_sort_method,
+                relaxed=self._reviews_relaxed)
+            return
+
         # update the stats (if needed). the caching can make them
         # wrong, so if the reviews we have in the list are more than the
         # stats we update manually
@@ -888,10 +905,22 @@
         if action:
             self._review_update_single(action, single_review)
         else:
-            curr_list = self.reviews.get_all_review_ids()
+            curr_list = set(self.reviews.get_all_review_ids())
+            retrieved_a_new_review = False
             for review in reviews_data:
                 if not review.id in curr_list:
+                    retrieved_a_new_review = True
                     self.reviews.add_review(review)
+            if reviews_data and not retrieved_a_new_review:
+                # We retrieved data, but nothing new.  Keep going.
+                self._reviews_server_page += 1
+                self.review_loader.get_reviews(
+                    self.app, self._reviews_ready_callback, 
+                    page=self._reviews_server_page,
+                    language=self._reviews_server_language,
+                    sort=self._review_sort_method,
+                    relaxed=self._reviews_relaxed)
+
         self.reviews.configure_reviews_ui()
 
     def on_weblive_progress(self, weblive, progress):
@@ -1767,7 +1796,11 @@
                     logging.debug("_get_icon_as_pixbuf:image_downloaded() %s" % image_file_path)
                     try:
                         pb = GdkPixbuf.Pixbuf.new_from_file(image_file_path)
-                        self.icon.set_from_pixbuf(pb)
+                        # fixes crash in testsuite if window is destroyed
+                        # and after that this callback is called (wouldn't
+                        # it be nice if gtk would do that automatically?)
+                        if self.icon.get_property("visible"):
+                            self.icon.set_from_pixbuf(pb)
                     except Exception as e:
                         LOG.warning("couldn't load downloadable icon file '%s': %s" % (image_file_path, e))
                     

=== modified file 'softwarecenter/ui/gtk3/widgets/reviews.py'
--- softwarecenter/ui/gtk3/widgets/reviews.py	2012-01-17 20:43:04 +0000
+++ softwarecenter/ui/gtk3/widgets/reviews.py	2012-01-18 18:21:04 +0000
@@ -39,7 +39,7 @@
     )
 
 
-from softwarecenter.i18n import get_languages
+from softwarecenter.i18n import get_languages, langcode_to_name
 
 from softwarecenter.netstatus import network_state_is_connected, get_network_watcher
 from softwarecenter.enums import (
@@ -55,6 +55,9 @@
 LOG_ALLOCATION = logging.getLogger("softwarecenter.ui.Gtk.get_allocation()")
 LOG = logging.getLogger(__name__)
 
+(COL_LANGNAME,
+ COL_LANGCODE) = range(2)
+
 class UIReviewsList(Gtk.VBox):
 
     __gsignals__ = {
@@ -127,10 +130,15 @@
         self.header.pack_end(self.sort_combo, False, False, 3)
 
         # change language
-        self.review_language = Gtk.ComboBoxText.new()
+        self.review_language = Gtk.ComboBox()
+        cell = Gtk.CellRendererText()
+        self.review_language.pack_start(cell, True)
+        self.review_language.add_attribute(cell, "text", COL_LANGNAME)
+        self.review_language_model = Gtk.ListStore(str, str)
         for lang in get_languages():
-            self.review_language.append_text(lang)
-        self.review_language.append_text(_('Any language'))
+            self.review_language_model.append( (langcode_to_name(lang), lang) )
+        self.review_language_model.append( (_('Any language'), 'any') )
+        self.review_language.set_model(self.review_language_model)
         self.review_language.set_active(0)
         self.review_language.connect(
             "changed", self._on_different_review_language_clicked)
@@ -307,9 +315,8 @@
         self.emit("different-review-language-clicked", language)
 
     def get_active_review_language(self):
-        language = self.review_language.get_active_text()
-        if language == _('Any language'):
-            language = 'any'
+        model = self.review_language.get_model()
+        language = model[self.review_language.get_active_iter()][COL_LANGCODE]
         return language
 
     def get_all_review_ids(self):

=== modified file 'test/gtk3/test_appdetailsview.py'
--- test/gtk3/test_appdetailsview.py	2012-01-17 17:22:11 +0000
+++ test/gtk3/test_appdetailsview.py	2012-01-18 20:12:05 +0000
@@ -6,7 +6,7 @@
 from testutils import setup_test_env
 setup_test_env()
 
-from mock import Mock
+from mock import Mock, patch
 
 from softwarecenter.db.application import Application
 from softwarecenter.testutils import get_mock_app_from_real_app, do_events
@@ -108,6 +108,10 @@
         view.show_app(app)
         self.assertEqual(view._reviews_server_page, 1)
 
+    def test_human_readable_name_in_view(self):
+        model = self.view.reviews.review_language.get_model()
+        self.assertEqual(model[0][0], "English")
+
     def test_pkgstatus_bar(self):
         # make sure configure is run with the various states
         # test
@@ -155,7 +159,6 @@
                 "for state %s the function %s was not called" % (state, func))
             mock.reset()
 
-
     def test_switch_language_resets_page(self):
         self.view._reviews_server_page = 4
 
@@ -170,6 +173,63 @@
 
         self.assertEqual(1, self.view._reviews_server_page)
 
+    @patch('softwarecenter.backend.reviews.rnr.ReviewLoaderSpawningRNRClient'
+           '.get_reviews')
+    def test_no_reviews_returned_attempts_relaxing(self, mock_get_reviews):
+        """AppDetailsView._reviews_ready_callback will attempt to drop the
+           origin and distroseries restriction if no reviews are returned
+           with the restrictions in place.
+        """
+        self.view._do_load_reviews()
+
+        self.assertEqual(1, mock_get_reviews.call_count)
+        kwargs = mock_get_reviews.call_args[1]
+        self.assertEqual(False, kwargs['relaxed'])
+        self.assertEqual(1, kwargs['page'])
+
+        # Now we come back with no data
+        application, callback = mock_get_reviews.call_args[0]
+        callback(application, [])
+
+        self.assertEqual(2, mock_get_reviews.call_count)
+        kwargs = mock_get_reviews.call_args[1]
+        self.assertEqual(True, kwargs['relaxed'])
+        self.assertEqual(1, kwargs['page'])
+
+    @patch('softwarecenter.backend.reviews.rnr.ReviewLoaderSpawningRNRClient'
+           '.get_reviews')
+    def test_all_duplicate_reviews_keeps_going(self, mock_get_reviews):
+        """AppDetailsView._reviews_ready_callback will fetch another page if
+           all data returned was already displayed in the reviews list.
+        """
+        # Fixme: Do we have a test factory?
+        review = Mock()
+        review.rating = 3
+        review.date_created = "2011-01-01 18:00:00"
+        review.version = "1.0"
+        review.summary = 'some summary'
+        review.review_text = 'Some text'
+        review.reviewer_username = "name"
+        review.reviewer_displayname = "displayname"
+
+        reviews = [review]
+        self.view.reviews.reviews = reviews
+        self.view._do_load_reviews()
+
+        self.assertEqual(1, mock_get_reviews.call_count)
+        kwargs = mock_get_reviews.call_args[1]
+        self.assertEqual(False, kwargs['relaxed'])
+        self.assertEqual(1, kwargs['page'])
+
+        # Now we come back with no NEW data
+        application, callback = mock_get_reviews.call_args[0]
+        callback(application, reviews)
+
+        self.assertEqual(2, mock_get_reviews.call_count)
+        kwargs = mock_get_reviews.call_args[1]
+        self.assertEqual(False, kwargs['relaxed'])
+        self.assertEqual(2, kwargs['page'])
+
 
 if __name__ == "__main__":
     import logging

=== modified file 'test/test_database.py'
--- test/test_database.py	2012-01-16 14:42:49 +0000
+++ test/test_database.py	2012-01-18 21:27:30 +0000
@@ -36,7 +36,7 @@
     def test_update_from_desktop_file(self):
         # ensure we index with german locales to test i18n
         os.environ["LANGUAGE"] = "de"
-        db = xapian.WritableDatabase("./data/test.db", 
+        db = xapian.WritableDatabase("./data/test.db",
                                      xapian.DB_CREATE_OR_OVERWRITE)
         res = update_from_app_install_data(db, self.cache, datadir="./data/desktop")
         self.assertTrue(res)
@@ -48,7 +48,7 @@
         self.assertEqual(i, 1)
 
     def test_update_from_appstream_xml(self):
-        db = xapian.WritableDatabase("./data/test.db", 
+        db = xapian.WritableDatabase("./data/test.db",
                                      xapian.DB_CREATE_OR_OVERWRITE)
         res = update_from_appstream_xml(db, self.cache, "./data/app-info/")
         self.assertTrue(res)
@@ -64,7 +64,7 @@
     def test_update_from_var_lib_apt_lists(self):
         # ensure we index with german locales to test i18n
         os.environ["LANGUAGE"] = "de"
-        db = xapian.WritableDatabase("./data/test.db", 
+        db = xapian.WritableDatabase("./data/test.db",
                                      xapian.DB_CREATE_OR_OVERWRITE)
         res = update_from_var_lib_apt_lists(db, self.cache, listsdir="./data/app-info/")
         self.assertTrue(res)
@@ -88,7 +88,7 @@
 
     def test_update_from_json_string(self):
         from softwarecenter.db.update import update_from_json_string
-        db = xapian.WritableDatabase("./data/test.db", 
+        db = xapian.WritableDatabase("./data/test.db",
                                      xapian.DB_CREATE_OR_OVERWRITE)
         cache = apt.Cache()
         p = os.path.abspath("./data/app-info-json/apps.json")
@@ -97,7 +97,7 @@
         self.assertEqual(db.get_doccount(), 1)
 
     def test_build_from_software_center_agent(self):
-        db = xapian.WritableDatabase("./data/test.db", 
+        db = xapian.WritableDatabase("./data/test.db",
                                      xapian.DB_CREATE_OR_OVERWRITE)
         cache = apt.Cache()
         # monkey patch distro to ensure we get data
@@ -114,7 +114,7 @@
             doc = db.get_document(p.docid)
             ppa = doc.get_value(XapianValues.ARCHIVE_PPA)
             self.assertTrue(ppa.startswith("commercial-ppa") and
-                            ppa.count("/") == 1, 
+                            ppa.count("/") == 1,
                             "ARCHIVE_PPA value incorrect, got '%s'" % ppa)
             self.assertTrue(
                 "-icon-" in doc.get_value(XapianValues.ICON))
@@ -127,11 +127,11 @@
     def test_license_string_data_from_software_center_agent(self):
         from softwarecenter.testutils import get_test_pkg_info
         #os.environ["SOFTWARE_CENTER_DEBUG_HTTP"] = "1"
-        os.environ["SOFTWARE_CENTER_BUY_HOST"] = "http://sc.staging.ubuntu.com/"
+        os.environ["SOFTWARE_CENTER_AGENT_HOST"] = "http://sc.staging.ubuntu.com/"
         # staging does not have a valid cert
         os.environ["PISTON_MINI_CLIENT_DISABLE_SSL_VALIDATION"] = "1"
         cache = get_test_pkg_info()
-        db = xapian.WritableDatabase("./data/test.db", 
+        db = xapian.WritableDatabase("./data/test.db",
                                      xapian.DB_CREATE_OR_OVERWRITE)
         res = update_from_software_center_agent(db, cache, ignore_cache=True)
         self.assertTrue(res)
@@ -140,7 +140,7 @@
             license = doc.get_value(XapianValues.LICENSE)
             self.assertNotEqual(license, "")
             self.assertNotEqual(license, None)
-        del os.environ["SOFTWARE_CENTER_BUY_HOST"]
+        del os.environ["SOFTWARE_CENTER_AGENT_HOST"]
 
     def test_application(self):
         db = StoreDatabase("/var/cache/software-center/xapian", self.cache)
@@ -149,7 +149,7 @@
         self.assertRaises(ValueError, AppDetails, db)
 
     def test_application_details(self):
-        db = xapian.WritableDatabase("./data/test.db", 
+        db = xapian.WritableDatabase("./data/test.db",
                                      xapian.DB_CREATE_OR_OVERWRITE)
         res = update_from_app_install_data(db, self.cache, datadir="./data/desktop")
         self.assertTrue(res)
@@ -191,7 +191,7 @@
         self.assertTrue(len(appdetails.version) > 2)
         # FIXME: screenshots will only work on ubuntu
         self.assertTrue(re.match(
-                "http://screenshots.ubuntu.com/screenshot-with-version/software-center/[\d.]+", 
+                "http://screenshots.ubuntu.com/screenshot-with-version/software-center/[\d.]+",
                 appdetails.screenshot))
         self.assertTrue(re.match(
                 "http://screenshots.ubuntu.com/thumbnail-with-version/software-center/[\d.]+",
@@ -210,9 +210,9 @@
         from softwarecenter.distro import get_distro
         distro = get_distro().get_codename()
         self.assertEqual(app.request, 'channel=' + distro + '-partner')
-        
+
     def ensure_installation_date_and_lazy_history_loading(self, appdetails):
-        # we run two tests, the first is to ensure that we get a 
+        # we run two tests, the first is to ensure that we get a
         # result from installation_data immediately (at this point the
         # history is not loaded yet) so we expect "None"
         self.assertEqual(appdetails.installation_date, None)
@@ -227,7 +227,7 @@
         self.assertNotEqual(appdetails.installation_date, None)
 
     def test_package_states(self):
-        db = xapian.WritableDatabase("./data/test.db", 
+        db = xapian.WritableDatabase("./data/test.db",
                                      xapian.DB_CREATE_OR_OVERWRITE)
         res = update_from_app_install_data(db, self.cache, datadir="./data/desktop")
         self.assertTrue(res)
@@ -282,37 +282,37 @@
             doc = m.document
             doc.get_value(value_time) >= last_time
             last_time = doc.get_value(value_time)
-            
+
     # FIXME: re-enable both tests once sc.staging.ubuntu.com has the new
     #        version of scagent with support for the publication date
     def disabled_test_for_purchase_apps_date_published(self):
         from softwarecenter.testutils import get_test_pkg_info
         #os.environ["SOFTWARE_CENTER_DEBUG_HTTP"] = "1"
-        os.environ["SOFTWARE_CENTER_BUY_HOST"] = "http://sc.staging.ubuntu.com/"
+        os.environ["SOFTWARE_CENTER_AGENT_HOST"] = "http://sc.staging.ubuntu.com/"
         # staging does not have a valid cert
         os.environ["PISTON_MINI_CLIENT_DISABLE_SSL_VALIDATION"] = "1"
         cache = get_test_pkg_info()
-        db = xapian.WritableDatabase("./data/test.db", 
+        db = xapian.WritableDatabase("./data/test.db",
                                      xapian.DB_CREATE_OR_OVERWRITE)
         res = update_from_software_center_agent(db, cache, ignore_cache=True)
         self.assertTrue(res)
-        
+
         for p in db.postlist(""):
             doc = db.get_document(p.docid)
             date_published = doc.get_value(XapianValues.DATE_PUBLISHED)
             # make sure that a date_published value is provided
             self.assertNotEqual(date_published, "")
             self.assertNotEqual(date_published, None)
-        del os.environ["SOFTWARE_CENTER_BUY_HOST"]
-        
+        del os.environ["SOFTWARE_CENTER_AGENT_HOST"]
+
     def disabled_test_for_purchase_apps_cataloged_time(self):
         from softwarecenter.testutils import get_test_pkg_info
         #os.environ["SOFTWARE_CENTER_DEBUG_HTTP"] = "1"
-        os.environ["SOFTWARE_CENTER_BUY_HOST"] = "http://sc.staging.ubuntu.com/"
+        os.environ["SOFTWARE_CENTER_AGENT_HOST"] = "http://sc.staging.ubuntu.com/"
         # staging does not have a valid cert
         os.environ["PISTON_MINI_CLIENT_DISABLE_SSL_VALIDATION"] = "1"
         cache = get_test_pkg_info()
-        db = xapian.WritableDatabase("./data/test.db", 
+        db = xapian.WritableDatabase("./data/test.db",
                                      xapian.DB_CREATE_OR_OVERWRITE)
         res = update_from_software_center_agent(db, cache, ignore_cache=True)
         self.assertTrue(res)
@@ -333,7 +333,7 @@
         # later time than axi package Ubuntu Software Center
         self.assertTrue(for_purch_cataloged_time > sc_cataloged_time)
 
-        del os.environ["SOFTWARE_CENTER_BUY_HOST"]
+        del os.environ["SOFTWARE_CENTER_AGENT_HOST"]
 
     def test_parse_axi_values_file(self):
         s = """

=== added file 'test/test_i18n.py'
--- test/test_i18n.py	1970-01-01 00:00:00 +0000
+++ test/test_i18n.py	2012-01-18 19:48:08 +0000
@@ -0,0 +1,52 @@
+#!/usr/bin/python
+
+import os
+import unittest
+
+
+from testutils import setup_test_env
+setup_test_env()
+from softwarecenter.i18n import (
+    init_locale, get_language,  get_languages, langcode_to_name)
+
+class TestI18n(unittest.TestCase):
+    """ tests the sc i18n """
+
+    def test_langcode_to_name(self):
+        self.assertEqual(langcode_to_name("de"), "German")
+
+    def test_locale(self):
+        # needs lang + country code
+        os.environ["LANGUAGE"] = "zh_TW"
+        self.assertEqual(get_language(), "zh_TW")
+        # language only
+        os.environ["LANGUAGE"] = "fr_FR"
+        self.assertEqual(get_language(), "fr")
+        # not existing one
+        os.environ["LANGUAGE"] = "xx_XX"
+        self.assertEqual(get_language(), "en")
+        # LC_ALL, no language
+        del os.environ["LANGUAGE"]
+        os.environ["LC_ALL"] = "C"
+        os.environ["LANG"] = "C"
+        self.assertEqual(get_language(), "en")
+
+    def test_invalid_get_languages(self):
+        # set LANGUAGE to a invalid language and verify that it correctly
+        # falls back to english
+        os.environ["LANGUAGE"] = "yxy_YYY"
+        self.assertEqual(get_languages(), ["en"])
+
+    def test_init_locale(self):
+        import locale
+        os.environ["LANGUAGE"] = ""
+        os.environ["LANG"] = "en_US.UTF-8"
+        init_locale()
+        self.assertEqual(locale.getlocale(locale.LC_ALL), ("en_US", "UTF-8"))
+        
+
+
+if __name__ == "__main__":
+    import logging
+    logging.basicConfig(level=logging.DEBUG)
+    unittest.main()

=== added file 'test/test_pyflakes.py'
--- test/test_pyflakes.py	1970-01-01 00:00:00 +0000
+++ test/test_pyflakes.py	2012-01-18 13:15:07 +0000
@@ -0,0 +1,16 @@
+#!/usr/bin/python
+
+import subprocess
+import unittest
+
+class TestPyflakesClean(unittest.TestCase):
+    """ ensure that the tree is pyflakes clean """
+
+    def test_pyflakes_clean(self):
+        self.assertEqual(subprocess.call(["pyflakes",".."]), 0)
+
+
+if __name__ == "__main__":
+    import logging
+    logging.basicConfig(level=logging.DEBUG)
+    unittest.main()

=== modified file 'test/test_reinstall_purchased.py'
--- test/test_reinstall_purchased.py	2012-01-16 14:42:49 +0000
+++ test/test_reinstall_purchased.py	2012-01-18 09:38:45 +0000
@@ -7,62 +7,116 @@
 import unittest
 import xapian
 
+from piston_mini_client import PistonResponseObject
 from testutils import setup_test_env
 setup_test_env()
-from softwarecenter.enums import XapianValues
+
+from softwarecenter.enums import (XapianValues,
+                                  AVAILABLE_FOR_PURCHASE_MAGIC_CHANNEL_NAME,
+                                  PURCHASED_NEEDS_REINSTALL_MAGIC_CHANNEL_NAME,
+                                  )
 from softwarecenter.db.database import StoreDatabase
-from softwarecenter.db.update import add_from_purchased_but_needs_reinstall_data
-
-# from
-#  https://wiki.canonical.com/Ubuntu/SoftwareCenter/10.10/Roadmap/SoftwareCenterAgent
-AVAILABLE_FOR_ME_JSON = """
-[
-    {
-        "archive_id": "mvo/private-test",
-        "deb_line": "deb https://username:randomp3atoken@private-ppa.launchpad.net/mvo/private-test/ubuntu maverick main #Personal access of username to private-test",
-        "purchase_price": "19.95",
-        "purchase_date": "2010-06-24 20:08:23",
-        "name": "Ubiteme",
-        "description": "One of the best strategy games you\'ll ever play!",
-        "package_name": "hellox",
-        "signing_key_id": "1024R/0EB12F05",
-        "series": {"natty": ["i386", "amd64"], 
-                   "maverick": ["i386", "amd64"], 
-                   "lucid": ["i386", "amd64"]}
-    }
-]
-"""
-
-class MockAvailableForMeItem(object):
-    def __init__(self, entry_dict):
-        for key, value in entry_dict.iteritems():
-            setattr(self, key, value)
-        self.MimeType = ""
-        self.department = []
-            
-class MockAvailableForMeList(list):
-
-    def __init__(self):
-        alist = json.loads(AVAILABLE_FOR_ME_JSON)
-        for entry_dict in alist:
-            self.append(MockAvailableForMeItem(entry_dict))
+from softwarecenter.db.update import (
+    add_from_purchased_but_needs_reinstall_data,
+    SCAPurchasedApplicationParser,
+    SCAApplicationParser,
+    )
+
+# Example taken from running:
+# PYTHONPATH=. utils/piston-helpers/piston_generic_helper.py --output=pickle \
+#           --debug --needs-auth SoftwareCenterAgentAPI subscriptions_for_me
+# then:
+#    f = open('my_subscriptions.pickle')
+#    subscriptions = pickle.load(f)
+#    completed_subs = [subs for subs in subscriptions if subs.state=='Complete']
+#    completed_subs[0].__dict__
+SUBSCRIPTIONS_FOR_ME_JSON = """
+[
+    {
+         "deb_line": "deb https://username:random3atoken@private-ppa.launchpad.net/commercial-ppa-uploaders/photobomb/ubuntu natty main",
+         "purchase_price": "2.99",
+         "purchase_date": "2011-09-16 06:37:52",
+         "state": "Complete",
+         "failures": [],
+         "open_id": "https://login.ubuntu.com/+id/ABCDEF",
+         "application": {
+              "archive_id": "commercial-ppa-uploaders/photobomb",
+              "signing_key_id": "1024R/75254D99",
+              "name": "Photobomb",
+              "package_name": "photobomb",
+              "description": "Easy and Social Image Editor\\nPhotobomb give you easy access to images in your social networking feeds, pictures on your computer and peripherals, and pictures on the web, and let\'s you draw, write, crop, combine, and generally have a blast mashing \'em all up. Then you can save off your photobomb, or tweet your creation right back to your social network."
+         },
+         "distro_series": {"code_name": "natty", "version": "11.04"}
+    }
+]
+"""
+# Taken directly from:
+# https://software-center.ubuntu.com/api/2.0/applications/en/ubuntu/oneiric/i386/
+AVAILABLE_APPS_JSON = """
+[
+    {
+        "archive_id": "commercial-ppa-uploaders/fluendo-dvd",
+        "signing_key_id": "1024R/75254D99",
+        "license": "Proprietary",
+        "name": "Fluendo DVD Player",
+        "package_name": "fluendo-dvd",
+        "support_url": "",
+        "series": {
+            "maverick": [
+                "i386",
+                "amd64"
+            ],
+            "natty": [
+                "i386",
+                "amd64"
+            ],
+            "oneiric": [
+                "i386",
+                "amd64"
+            ]
+        },
+        "price": "24.95",
+        "demo": null,
+        "date_published": "2011-12-05 18:43:21.653868",
+        "status": "Published",
+        "channel": "For Purchase",
+        "icon_data": "...",
+        "department": [
+            "Sound & Video"
+        ],
+        "archive_root": "https://private-ppa.launchpad.net/",
+        "screenshot_url": "http://software-center.ubuntu.com/site_media/screenshots/2011/05/fluendo-dvd-maverick_.png",
+        "tos_url": "https://software-center.ubuntu.com/licenses/3/",
+        "icon_url": "http://software-center.ubuntu.com/site_media/icons/2011/05/fluendo-dvd.png",
+        "categories": "AudioVideo",
+        "description": "Play DVD-Videos\\r\\n\\r\\nFluendo DVD Player is a software application specially designed to\\r\\nreproduce DVD on Linux/Unix platforms, which provides end users with\\r\\nhigh quality standards.\\r\\n\\r\\nThe following features are provided:\\r\\n* Full DVD Playback\\r\\n* DVD Menu support\\r\\n* Fullscreen support\\r\\n* Dolby Digital pass-through\\r\\n* Dolby Digital 5.1 output and stereo downmixing support\\r\\n* Resume from last position support\\r\\n* Subtitle support\\r\\n* Audio selection support\\r\\n* Multiple Angles support\\r\\n* Support for encrypted discs\\r\\n* Multiregion, works in all regions\\r\\n* Multiple video deinterlacing algorithms"
+    }
+]
+"""
+
 
 class TestPurchased(unittest.TestCase):
     """ tests the store database """
 
+    def _make_available_for_me_list(self):
+        my_subscriptions = json.loads(SUBSCRIPTIONS_FOR_ME_JSON)
+        return list(
+            PistonResponseObject.from_dict(subs) for subs in my_subscriptions)
+
     def setUp(self):
         # use fixture apt data
         apt_pkg.config.set("APT::Architecture", "i386")
         apt_pkg.config.set("Dir::State::status",
                            "./data/appdetails/var/lib/dpkg/status")
         # create mocks
-        self.available_to_me = MockAvailableForMeList()
+        self.available_to_me = self._make_available_for_me_list()
         self.cache = apt.Cache()
 
     def test_reinstall_purchased_mock(self):
         # test if the mocks are ok
         self.assertEqual(len(self.available_to_me), 1)
-        self.assertEqual(self.available_to_me[0].package_name, "hellox")
+        self.assertEqual(
+            self.available_to_me[0].application['package_name'], "photobomb")
 
     def test_reinstall_purchased_xapian(self):
         db = StoreDatabase("/var/cache/software-center/xapian", self.cache)
@@ -81,12 +135,167 @@
         self.assertEqual(len(matches), 1)
         for m in matches:
             doc = db.xapiandb.get_document(m.docid)
-            self.assertEqual(doc.get_value(XapianValues.PKGNAME), "hellox")
-            self.assertEqual(doc.get_value(XapianValues.ARCHIVE_SIGNING_KEY_ID), "1024R/0EB12F05")
+            self.assertEqual(doc.get_value(XapianValues.PKGNAME), "photobomb")
+            self.assertEqual(
+                doc.get_value(XapianValues.ARCHIVE_SIGNING_KEY_ID),
+                "1024R/75254D99")
             self.assertEqual(doc.get_value(XapianValues.ARCHIVE_DEB_LINE),
-                                           "deb https://username:randomp3atoken@private-ppa.launchpad.net/mvo/private-test/ubuntu maverick main #Personal access of username to private-test")
-            break # only one match
-        
+                "deb https://username:random3atoken@"
+                 "private-ppa.launchpad.net/commercial-ppa-uploaders"
+                 "/photobomb/ubuntu natty main")
+
+
+class SCAApplicationParserTestCase(unittest.TestCase):
+
+    def _make_application_parser(self, piston_application=None):
+        if piston_application is None:
+            piston_application = PistonResponseObject.from_dict(
+                json.loads(AVAILABLE_APPS_JSON)[0])
+        return SCAApplicationParser(piston_application)
+
+    def test_parses_application_from_available_apps(self):
+        parser = self._make_application_parser()
+        inverse_map = dict(
+            (val, key) for key, val in SCAApplicationParser.MAPPING.items())
+
+        # Delete the keys which are not yet provided via the API:
+        del(inverse_map['video_url'])
+
+        for key in inverse_map:
+            self.assertTrue(parser.has_option_desktop(inverse_map[key]))
+            self.assertEqual(
+                getattr(parser.sca_application, key),
+                parser.get_desktop(inverse_map[key]))
+
+    def test_keys_not_provided_by_api(self):
+        parser = self._make_application_parser()
+
+        self.assertFalse(parser.has_option_desktop('Video-Url'))
+        self.assertTrue(parser.has_option_desktop('Type'))
+        self.assertEqual('Application', parser.get_desktop('Type'))
+
+    def test_thumbnail_is_screenshot(self):
+        parser = self._make_application_parser()
+
+        self.assertEqual(
+            "http://software-center.ubuntu.com/site_media/screenshots/"
+            "2011/05/fluendo-dvd-maverick_.png",
+            parser.get_desktop('Thumbnail-Url'))
+
+    def test_extracts_description(self):
+        parser = self._make_application_parser()
+
+        self.assertEqual("Play DVD-Videos", parser.get_desktop('Comment'))
+        self.assertEqual(
+            "Fluendo DVD Player is a software application specially designed "
+            "to\r\nreproduce DVD on Linux/Unix platforms, which provides end "
+            "users with\r\nhigh quality standards.\r\n\r\nThe following "
+            "features are provided:\r\n* Full DVD Playback\r\n* DVD Menu "
+            "support\r\n* Fullscreen support\r\n* Dolby Digital pass-through"
+            "\r\n* Dolby Digital 5.1 output and stereo downmixing support\r\n"
+            "* Resume from last position support\r\n* Subtitle support\r\n"
+            "* Audio selection support\r\n* Multiple Angles support\r\n"
+            "* Support for encrypted discs\r\n"
+            "* Multiregion, works in all regions\r\n"
+            "* Multiple video deinterlacing algorithms",
+            parser.get_desktop('Description'))
+
+    def test_desktop_categories_uses_department(self):
+        parser = self._make_application_parser()
+
+        self.assertEqual([u'DEPARTMENT:Sound & Video', "AudioVideo"],
+            parser.get_desktop_categories())
+
+    def test_desktop_categories_no_department(self):
+        piston_app = PistonResponseObject.from_dict(
+            json.loads(AVAILABLE_APPS_JSON)[0])
+        del(piston_app.department)
+        parser = self._make_application_parser(piston_app)
+
+        self.assertEqual(["AudioVideo"], parser.get_desktop_categories())
+
+    def test_magic_channel(self):
+        parser = self._make_application_parser()
+
+        self.assertEqual(
+            AVAILABLE_FOR_PURCHASE_MAGIC_CHANNEL_NAME,
+            parser.get_desktop('Channel'))
+
+
+class SCAPurchasedApplicationParserTestCase(unittest.TestCase):
+
+    def _make_application_parser(self, piston_subscription=None):
+        if piston_subscription is None:
+            piston_subscription = PistonResponseObject.from_dict(
+                json.loads(SUBSCRIPTIONS_FOR_ME_JSON)[0])
+
+        return SCAPurchasedApplicationParser(piston_subscription)
+
+    def test_get_desktop_subscription(self):
+        parser = self._make_application_parser()
+
+        expected_results = {
+             "Deb-Line": "deb https://username:random3atoken@"
+                         "private-ppa.launchpad.net/commercial-ppa-uploaders"
+                         "/photobomb/ubuntu natty main",
+             "Purchased-Date": "2011-09-16 06:37:52",
+            }
+        for key in expected_results:
+            result = parser.get_desktop(key)
+            self.assertEqual(expected_results[key], result)
+
+    def test_get_desktop_application(self):
+        # The parser passes application attributes through to
+        # an application parser for handling.
+        parser = self._make_application_parser()
+
+        expected_results = {
+            "Name": "Photobomb (already purchased)",
+            "Package": "photobomb",
+            "Signing-Key-Id": "1024R/75254D99",
+            "PPA": "commercial-ppa-uploaders/photobomb",
+            }
+        for key in expected_results.keys():
+            result = parser.get_desktop(key)
+            self.assertEqual(expected_results[key], result)
+
+    def test_has_option_desktop_includes_app_keys(self):
+        # The SCAPurchasedApplicationParser handles application keys also
+        # (passing them through to the composited application parser).
+        parser = self._make_application_parser()
+
+        for key in ('Name', 'Package', 'Signing-Key-Id', 'PPA'):
+            self.assertTrue(parser.has_option_desktop(key))
+        for key in ('Deb-Line', 'Purchased-Date'):
+            self.assertTrue(parser.has_option_desktop(key),
+                    'Key: {0} was not an option.'.format(key))
+
+    def test_license_key_present(self):
+        piston_subscription = PistonResponseObject.from_dict(
+            json.loads(SUBSCRIPTIONS_FOR_ME_JSON)[0])
+        piston_subscription.license_key = 'abcd'
+        piston_subscription.license_key_path = '/foo'
+        parser = self._make_application_parser(piston_subscription)
+
+        self.assertTrue(parser.has_option_desktop('License-Key'))
+        self.assertTrue(parser.has_option_desktop('License-Key-Path'))
+        self.assertEqual('abcd', parser.get_desktop('License-Key'))
+        self.assertEqual('/foo', parser.get_desktop('License-Key-Path'))
+
+    def test_license_key_not_present(self):
+        parser = self._make_application_parser()
+
+        self.assertFalse(parser.has_option_desktop('License-Key'))
+        self.assertFalse(parser.has_option_desktop('License-Key-Path'))
+
+    def test_magic_channel(self):
+        parser = self._make_application_parser()
+
+        self.assertEqual(
+            PURCHASED_NEEDS_REINSTALL_MAGIC_CHANNEL_NAME,
+            parser.get_desktop('Channel'))
+
+
 if __name__ == "__main__":
     logging.basicConfig(level=logging.DEBUG)
     unittest.main()

=== modified file 'test/test_reviews.py'
--- test/test_reviews.py	2012-01-17 13:58:02 +0000
+++ test/test_reviews.py	2012-01-19 09:23:54 +0000
@@ -12,7 +12,7 @@
 from softwarecenter.backend.reviews.rnr import (
     ReviewLoaderSpawningRNRClient as ReviewLoader)
 from softwarecenter.testutils import get_test_pkg_info, get_test_db
-from softwarecenter.backend.reviews.rnr_helpers import SubmitReviewsApp
+from softwarecenter.ui.gtk3.review_gui_helper import SubmitReviewsApp
 
 
 class TestReviewLoader(unittest.TestCase):

=== modified file 'test/test_scagent.py'
--- test/test_scagent.py	2012-01-16 14:42:49 +0000
+++ test/test_scagent.py	2012-01-17 15:54:36 +0000
@@ -1,6 +1,7 @@
 #!/usr/bin/python
 
 from gi.repository import GObject
+from mock import patch
 import unittest
 
 from testutils import setup_test_env
@@ -31,8 +32,7 @@
         self.loop.run()        
         self.assertFalse(self.error)
 
-    # disabled for now as this is not yet on staging or production
-    def disabled_test_scagent_query_exhibits(self):
+    def test_scagent_query_exhibits(self):
         sca = SoftwareCenterAgent()
         sca.connect("exhibits", self.on_query_done)
         sca.connect("error", self.on_query_error)
@@ -40,6 +40,18 @@
         self.loop.run()  
         self.assertFalse(self.error)
 
+    def test_scaagent_query_available_for_me_uses_complete_only(self):
+        run_generic_piston_helper_fn = (
+            'softwarecenter.backend.spawn_helper.SpawnHelper.'
+            'run_generic_piston_helper')
+        with patch(run_generic_piston_helper_fn) as mock_run_piston_helper:
+            sca = SoftwareCenterAgent()
+            sca.query_available_for_me()
+
+            mock_run_piston_helper.assert_called_with(
+                'SoftwareCenterAgentAPI', 'subscriptions_for_me',
+                complete_only=True)
+
 
 if __name__ == "__main__":
     import logging

=== modified file 'test/test_utils.py'
--- test/test_utils.py	2012-01-16 14:42:49 +0000
+++ test/test_utils.py	2012-01-18 18:03:39 +0000
@@ -10,7 +10,6 @@
                                   release_filename_in_lists_from_deb_line,
                                   get_http_proxy_string_from_libproxy,
                                   )
-from softwarecenter.i18n import get_language
 
 
 class TestSCUtils(unittest.TestCase):
@@ -28,22 +27,6 @@
         self.assertEqual(release_filename_in_lists_from_deb_line(debline),
                          "security.ubuntu.com_ubuntu_dists_maverick-security_Release")
 
-    def test_locale(self):
-        # needs lang + country code
-        os.environ["LANGUAGE"] = "zh_TW"
-        self.assertEqual(get_language(), "zh_TW")
-        # language only
-        os.environ["LANGUAGE"] = "fr_FR"
-        self.assertEqual(get_language(), "fr")
-        # not existing one
-        os.environ["LANGUAGE"] = "xx_XX"
-        self.assertEqual(get_language(), "en")
-        # LC_ALL, no language
-        del os.environ["LANGUAGE"]
-        os.environ["LC_ALL"] = "C"
-        os.environ["LANG"] = "C"
-        self.assertEqual(get_language(), "en")
-
     def test_get_http_proxy_from_gsettings(self):
         from softwarecenter.utils import get_http_proxy_string_from_gsettings
         # FIXME: do something more meaningful here once I figured out

=== modified file 'utils/submit_review_gtk3.py'
--- utils/submit_review_gtk3.py	2012-01-17 16:35:35 +0000
+++ utils/submit_review_gtk3.py	2012-01-19 09:23:54 +0000
@@ -34,7 +34,7 @@
 from softwarecenter.paths import SOFTWARE_CENTER_CACHE_DIR
 from softwarecenter.db.database import Application
 
-from softwarecenter.backend.reviews.rnr_helpers import (
+from softwarecenter.ui.gtk3.review_gui_helper import (
     DeleteReviewApp,
     ReportReviewApp,
     SubmitReviewsApp,

